// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include <cmath>

#include "DistributedSparseMatrix.h"
#include "Muesli.h"

double square(double x) {
	return x * x;
}

double sum(double x, double y) {
	return x + y;
}

int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);

	msl::DistributedSparseMatrix<double> dsm(4, 4, 2, 2, 0);

	dsm.setPrecision(0);

	for(int i = 0; i < 4; i++) {
		for(int j = 0; j < 4; j++) {
			//if((i % 2 == 0 && j % 2 == 0) || (i % 2 == 1 && j % 2 == 1)) {
				dsm.setElement(i + j + 1, i, j);
			//}
		}
	}

	dsm.print();

	dsm.mapInPlace(&square);

	printf("||A||_F = %f\n", sqrt(dsm.fold(&sum)));

	msl::TerminateSkeletons();

	return 0;
}
