// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include "Double.h"
#include "Frame.h"
#include "TestFrame.h"

void msl::test::frame::testFrame() {
	printf("Welcome to the test suite for the Frame class.\n");

	char* buffer;
	int size;
	long myId   = 0;
	long origId = 0;
	long snd    = 0;
	long pool   = 0;
	msl::test::Double myData(0);

	msl::Frame<msl::test::Double> a(myId, origId, snd, pool, &myData);
	msl::Frame<msl::test::Double>* b = new msl::Frame<msl::test::Double>();
	msl::test::Double c(1);

	size = a.getSize();
	buffer = new char[size];

	a.reduce(buffer, size);
	b->expand(buffer, size);
	a.getData();
	a.getID();
	a.getOriginator();
	a.getPoolID();
	a.getRootNodeID();
	a.setData(&c);
	a.setID(myId);
	a.setOriginator(origId);
	a.setPoolID(pool);
	a.setRootNodeID(snd);
	
	delete b;

	printf("All tests have been passed successfully!\n\n");
}

int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);
	msl::test::frame::testFrame();
	msl::TerminateSkeletons();
	return 0;
}
