// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include <iostream>

#include "Atomic.h"
#include "Double.h"
#include "Process.h"
#include "TestProcess.h"

/* Testing Atomic as a special process.
*/
void msl::test::process::testProcess() {
	printf("Welcome to the test suite for the Process class.\n");

	int n = 1;
	msl::Atomic<msl::test::Double, msl::test::Double> a(f, n);
	msl::ProcessorNo x = 0;
	msl::ProcessorNo y = 2;

	a.setNextReceiver(0);
	a.setPredecessors(&x, 1);
	a.setSuccessors(&y, 1);
	a.addProcessRecvTime(0);
	a.addProcessSendTime(0);
	a.addReceivedStops();
	a.addReceivedTT();
	a.copy();
	a.getEntrances();
	a.getExits();
	a.getNextReceiver();
	a.getNumOfEntrances();
	a.getNumOfExits();
	a.getNumOfPredecessors();
	a.getNumOfSuccessors();
	a.getPredecessors();
	a.getProcessRecvTime();
	a.getProcessSendTime();
	a.getRandomReceiver();
	a.getReceivedStops();
	a.getReceivedTT();
	a.getReceiver();
	a.getSuccessors();
	a.isKnownSource(x);
	a.newSeed();
	a.resetReceivedStops();
	a.resetReceivedTT();

	printf("All tests have been passed successfully!\n\n");
}

msl::test::Double* msl::test::process::f(msl::test::Double* x) {
	return x;
}


int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);
	msl::test::process::testProcess();
	msl::TerminateSkeletons();
	return 0;
}
