// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include "Curry.h"
#include "Double.h"
#include "TestWorkpool.h"
#include "Workpool.h"

void msl::test::workpool::testWorkpool() {
	printf("Welcome to the test suite for the Workpool class.\n");

	msl::Workpool<msl::test::Double>* a = new msl::Workpool<msl::test::Double>(betterThan);
	msl::Workpool<msl::test::Double> b(curry(betterThan));
	msl::test::Double c(0);
	msl::ProcessorNo d = 0;

	// calling get() or top() on an empty workpool will
	// result in an emptyheapexception -> insert element
	a->insert(c);
	a->fresh();
	a->get();
	a->getBetterThanFunction();
	// see above
	a->insert(c);
	a->top();
	a->isEmpty();
	a->reset();
	a->show(d);

	delete a;

	printf("All tests have been passed successfully!\n\n");
}

bool msl::test::workpool::betterThan(msl::test::Double* a, msl::test::Double* b) {
	return true;
}


int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);
	msl::test::workpool::testWorkpool();
	msl::TerminateSkeletons();
	return 0;
}
