// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include "Double.h"
#include "TestWorkpoolManager.h"
#include "WorkpoolManager.h"

void msl::test::workpoolmanager::testWorkpoolManager() {
	printf("Welcome to the test suite for the WorkpoolManager class.\n");

	long myId   = 0;
	long origId = 0;
	long snd    = 0;
	long pool   = 0;
	msl::test::Double myData(0);
	msl::WorkpoolManager<msl::test::Double>* a = new msl::WorkpoolManager<msl::test::Double>();
	msl::Frame<msl::test::Double> b(myId, origId, snd, pool, &myData);

	a->insert(&b);
	a->get();
	// calling getLoad() will result in an exception, unless the workpool
	// storea at least WorkpoolManager.THRESHOLD = 2 elements
	a->insert(&b);
	a->insert(&b);
	a->getLoad();
	a->getSize();
	a->hasLoad();
	a->isEmpty();
	a->show();

	delete a;
	
	printf("All tests have been passed successfully!\n\n");
}


int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);
	msl::test::workpoolmanager::testWorkpoolManager();
	msl::TerminateSkeletons();
	return 0;
}
