// **********************************************************************************************************
// *																										*
// * This Software is published under the MIT License.														*
// * For more information and the license text, please refer to the file 'License' located in the zip file. *
// *																										*
// * Copyright (c) 2001-2011 Steffen Ernsting, Philipp Ciechanowicz, Michael Poldner and Herbert Kuchen     *                 
// *        		{s.ernsting|ciechanowicz|poldner|kuchen}@uni-muenster.de              					*
// *																										*	
// **********************************************************************************************************

#include "Double.h"
#include "TestWorkpoolManager2.h"
#include "WorkpoolManager2.h"

void msl::test::workpoolmanager::testWorkpoolManager2() {
	printf("Welcome to the test suite for the WorkpoolManager2 class.\n");

	int nop     = 1;
	int p       = 0;
	int ppid    = 0;
	long myId   = 0;
	long origId = 0;
	long snd    = 0;
	long pool   = 0;
	msl::test::Double myData(0);
	msl::WorkpoolManager2<msl::test::Double>* a = new msl::WorkpoolManager2<msl::test::Double>(nop);
	msl::Frame<msl::test::Double> b(myId, origId, snd, pool, &myData);

	a->insert(&b);
	a->get();
	// calling getLoad() will result in an exception, unless the work-
	// pool storea at least WorkpoolManager2.THRESHOLD = 3 elements
	a->insert(&b);
	a->insert(&b);
	a->insert(&b);
	a->getLoad();
	a->getSize(p);
	a->hasLoad();
	a->insert(&b);
	a->isEmpty();
	a->setPrimaryPoolID(ppid);
	a->show();

	delete a;
	
	printf("All tests have been passed successfully!\n\n");
}


int main(int argc, char** argv) {
	msl::InitSkeletons(argc, argv);
	msl::test::workpoolmanager::testWorkpoolManager2();
	msl::TerminateSkeletons();
	return 0;
}
